#include <QCoreApplication>
#include <QDebug>
#include <QThread>

#include "VideoSocket.h"

VideoSocket::VideoSocket(QObject *parent)
    : QTcpSocket(parent) {
}

VideoSocket::~VideoSocket() {
}

qint32 VideoSocket::subThreadRecvData(quint8 *buf, qint32 bufSize) {
    if (!buf) {
        return 0;
    }
    // this function cant call in main thread
    Q_ASSERT(QCoreApplication::instance()->thread() != QThread::currentThread());

    while (bytesAvailable() < bufSize) {
        if (!waitForReadyRead(-1)) {
            return 0;
        }
    }

    // recv data
    return read((char *)buf, bufSize);
}
